#ifndef _STRINGLIST_H
#define _STRINGLIST_H

/* C API defines */
#define StringList_isStringList_NUM 0
#define StringList_isStringList_RETURN int
#define StringList_isStringList_PROTO (PyObject *list)

#define StringList_SetItemInit_NUM 1
#define StringList_SetItemInit_RETURN int
#define StringList_SetItemInit_PROTO (PyObject *self, PyObject *key, PyObject *value)

#define StringList_Update_NUM 2
#define StringList_Update_RETURN int
#define StringList_Update_PROTO (PyObject *self, PyObject *value)

#define StringList_New_NUM 3
#define StringList_New_RETURN PyObject *
#define StringList_New_PROTO (int size, int readonly)

/* Total number of C API pointers */
#define StringList_API_pointers 4

#ifdef _STRINGLIST_C
/*
==========================================================================================
Structure definitions
==========================================================================================
*/
typedef struct{
    PyListObject list;
    int readonly;
}StringListObject;

/*
==========================================================================================
Function definitions
==========================================================================================
*/
static StringList_isStringList_RETURN StringList_isStringList StringList_isStringList_PROTO;
static StringList_SetItemInit_RETURN StringList_SetItemInit StringList_SetItemInit_PROTO;
static StringList_Update_RETURN StringList_Update StringList_Update_PROTO;
static StringList_New_RETURN StringList_New StringList_New_PROTO;

#else
/*
==========================================================================================
C_API
==========================================================================================
*/
#define import_StringList() {if (_import_StringList() < 0) {PyErr_Print(); PyErr_SetString(PyExc_ImportError, "MeDigiT._StringList._C_API failed to import"); return NULL; } }
#define StringList_isStringList \
    (*(StringList_isStringList_RETURN (*)StringList_isStringList_PROTO) StringList_API[StringList_isStringList_NUM])
#define StringList_SetItemInit \
    (*(StringList_SetItemInit_RETURN (*)StringList_SetItemInit_PROTO) StringList_API[StringList_SetItemInit_NUM])
#define StringList_Update \
    (*(StringList_Update_RETURN (*)StringList_Update_PROTO) StringList_API[StringList_Update_NUM])
#define StringList_New \
    (*(StringList_New_RETURN (*)StringList_New_PROTO) StringList_API[StringList_New_NUM])


/* Return -1 on error, 0 on success.
 * PyCapsule_Import will set an exception if there's an error.
 */
static void **StringList_API;
static int
_import_StringList(void)
{
    StringList_API = (void **)PyCapsule_Import("MeDigiT._StringList._C_API", 0);
    return (StringList_API != NULL) ? 0 : -1;
}

#endif
#endif