#!python3
from setuptools import setup, Extension
import os
import sys
from sysconfig import get_paths

_MeDigiTFolder = os.path.dirname(os.path.realpath(__file__))

file = sys.argv.pop(-1)
modelname,_ = os.path.splitext(os.path.basename(file))
include = [os.path.join(_MeDigiTFolder,"Models","include")]

Model = Extension("MeDigiT.Models." + modelname,
              include_dirs = include,
              sources = [file],
              library_dirs=[os.path.join(_MeDigiTFolder,"Models","include")],
              libraries=["ExtraFormulas"])

setup(name="MeDigiT.Models." + modelname,
      version="1.0.0",
      description=f"{modelname} MeDigiT model",
      ext_modules=[Model])