typedef int SUNDIALS_Integrate(void *self, int nrtimesteps, double *timevector, double *statevector, double *derivativevector);
typedef int SUNDIALS_SetOptions(void *self, PyObject *options);
typedef void SUNDIALS_Free(void *self);

typedef struct{
	int nreventstriggered;
	double *eventtimedata;
	char *eventstatusdata;
	double *featuredata;
}SUNDIALS_SimData;

typedef struct{
	SUNDIALS_Integrate *integrate;
	SUNDIALS_SetOptions *setoptions;
	SUNDIALS_Free *free;
	SUNDIALS_SimData simdata;
}SUNDIALSObject;


SUNDIALSObject* CVODE55_init(void *user_data, int nrstates, int nrevents, int nrfeatures, PyObject *options);
SUNDIALSObject* IDA55_init(void *user_data, int nrstates, int nrevents, int nrfeatures, double *idvector, PyObject *options);